--
-- shovelMovementFill
--
-- author: upsidedown
-- date: 21.03.2013
-- 
-- V1.1: dietFeeders returned to standard loading, grabbing shovels support, extra support for T174 digger, moving distance for filling reduced to 0.8m


shovelMovementFill = {};

function shovelMovementFill.prerequisitesPresent(specializations)
	--return SpecializationUtil.hasSpecialization(shovel, specializations);
	return true;
end;

function shovelMovementFill:load(xmlFile)
	
end;

function shovelMovementFill:postLoad(xmlFile)
	self.fillShovelFromTrigger = Utils.overwrittenFunction(self.fillShovelFromTrigger, shovelMovementFill.fillShovelFromTrigger);
end;

function shovelMovementFill:delete()
	
end;

function shovelMovementFill:mouseEvent(posX, posY, isDown, isUp, button)
end;

function shovelMovementFill:keyEvent(unicode, sym, modifier, isDown)
end;

function shovelMovementFill:update(dt)
end;

function shovelMovementFill:updateTick(dt)
	
end;

function shovelMovementFill:fillShovelFromTrigger(superFunc,shovelTrigger, deltaFillLevel, fillType, dt)
	local moveDistance = 0.8; --this parameters determines the distance to move in order to fill the shovel
	
	
	local finalDelta = 0;
	local stdShovel = true;
	
	
	if self.mixerWagonBaleTriggerCallback ~= nil then
		stdShovel = false;
	end;
	
	if self.attacherVehicle ~= nil then
		if self.attacherVehicle.name ~= nil then
			if string.find(self.attacherVehicle.name,"T 174")~= nil then
				stdShovel = false;
			end;
		end;		
	end
	
	--local fillFactor = 1.0;
    if self.shovelOpenNode ~= nil then
		local oldX = Utils.getNoNil(self.shovelOpenNodeOldX,0);
        local x,_,_ = getRotation(self.shovelOpenNode);
		-- if x ~= oldX then
			self.shovelOpenNodeOldX = x;
			-- stdShovel = false;
		-- end;
        if self.shovelOpenDirection > 0 then
            if x < oldX then
                stdShovel = false;
            end;
        else
            if x > oldX then
				stdShovel = false;
            end;
        end
    end;
	
	
	--if self.movingDirection > 0 then
	if stdShovel then
		local _,_,mZ = worldToLocal(self.components[1].node,self.lastPosition[1],self.lastPosition[2],self.lastPosition[3])
		local v = mZ/dt*1000;
		if v < -0.1 then
			local newDF = math.min(-mZ/moveDistance*self.capacity,deltaFillLevel);
			finalDelta = superFunc(self,shovelTrigger, newDF, fillType, dt);
		end;
	else
		finalDelta = superFunc(self,shovelTrigger, deltaFillLevel, fillType, dt);
	end;
	
	--end;
	
	return finalDelta;
end;


function shovelMovementFill:draw()

	
end;


function shovelMovementFill:onDeactivate()
	
end;